@iscript

class QLinearMover
{
	// 

	var path; // _z
	var time; // _ʉ߂̂ɕKvȎ
	var accel; // xIȓ邩ǂ
	var pointCount; // path.count -1
	var finalFunction; // ړIɌĂԊ֐
	var startTick; // ړJneBbN
	var totalTime; // Ŝ̎
	var delayTimer; // Jn܂ő҂߂̃^C}
	var moving = false; // ړ
	var first = true; // ̃nhĂяo
	var nextStop = false; // ̃nhĂяoŒ~邩

	function QLinearMover( path, time, accel, finalfunction)
	{
		this.path = path;
		this.time = time;
		this.accel = accel;
		this.finalFunction = finalfunction;
		totalTime = (pointCount = (path.count \ 3 - 1)) * time;
	}

	function finalize()
	{
		stopMove();
		if(delayTimer !== void) invalidate delayTimer;
	}

	function startMove(delay)
	{
		// ړJn
		if(delay != 0)
		{
			delayTimer = new Timer(onDelayTimer, '');
			delayTimer.interval = delay;
			delayTimer.enabled = true;
			moving = true;
		}
		else
		{
			System.addContinuousHandler(handler); // ContinuousHandlers ɒǉ
			moving = true;
		}
	}

	function onDelayTimer()
	{
		// delayTimer 
		delayTimer.enabled = false;
		System.addContinuousHandler(handler);
	}

	function stopMove()
	{
		// ړI
		if(moving)
		{
			// ŏIʒuɈړ
			if(kag isvalid)
			{
				var idx = int(pointCount*3);
				var p = path;
				kag.setLayerPos(p[idx], p[idx+1]);
			}
			System.removeContinuousHandler(handler);
			moving = false;
			finalFunction();
		}
	}

	function handler(tick)
	{
		// ړɌĂ΂
		if(nextStop || !(kag isvalid)) { stopMove();  return; }
		if(first) startTick = tick, first = false;
		tick -= startTick;
		if(tick >= totalTime)
		{
			nextStop = true;
			var idx = int(pointCount*3);
			var p = path;
			kag.setLayerPos(p[idx], p[idx+1]);
			return;
		}

		if(accel < 0)
		{
			// ㌷ ( ŏAXɒxȂ )
			tick = 1.0 - tick / totalTime;
			tick = Math.pow(tick, -accel);
			tick = int ( (1.0 - tick) * totalTime );
		}
		else if(accel > 0)
		{
			//  ( ŏ͓xAXɑȂ )
			tick = tick / totalTime;
			tick = Math.pow(tick, accel);
			tick = int ( tick * totalTime );
		}

		move(tick);
	}

	function move(tick)
	{
		var index = tick \ time * 3;
		var ratio = tick % time / time;
		var p = path;
		var sx = p[index];
		var sy = p[index+1];
		var so = p[index+2];
		var ex = p[index+3];
		var ey = p[index+4];
		var eo = p[index+5];

		var l = int((ex-sx)*ratio + sx);
		var t = int((ey-sy)*ratio + sy);
		var o = eo >= 256 ? so : int((eo-so)*ratio + so);

		kag.setLayerPos(l, t);
	}
}


class QSplineMover extends QLinearMover
{
	// XvC
	var zx = []; // XvC[N
	var zy = []; // XvC[N

	function QSplineMover( path, time, accel, finalfunction)
	{
		super.QLinearMover(...);

		if(path.count < 9)
		{
			// 3 _ȉ ( w肷̂͂̂2_ ) ͕⊮łȂ
			throw new Exception("2 _ȏw肵Ă");
		}

		// XvCԂɕKvȃ[NvZ
		var points = path.count \ 3;
		var tmpx = [], tmpy = [];
		var tx = zx, ty = zy;
		tx[0] = 0;
		ty[0] = 0;
		tx[points-1] = 0;
		ty[points-1] = 0;

		for(var i = points-2, pi = path.count-6; i >= 0; i--, pi -= 3)
		{
			tmpx[i+1] = (path[pi + 3] - path[pi  ]);
			tmpy[i+1] = (path[pi + 4] - path[pi+1]);
		}

		tx[1] = tmpx[2] - tmpx[1] - tx[0];
		ty[1] = tmpy[2] - tmpy[1] - ty[0];

		tmpx[1] = 4;
		tmpy[1] = 4;

		var lim = points - 2;
		for(var i = 1, pi = 3; i < lim; i++, pi += 3)
		{
			var x = 1 / tmpx[i];
			var y = 1 / tmpy[i];
			tx[i+1] = tmpx[i+2] - tmpx[i+1] - tmpx[i] * x;
			ty[i+1] = tmpy[i+2] - tmpy[i+1] - tmpy[i] * y;
			tmpx[i+1] = 4 - x;
			tmpy[i+1] = 4 - y;
		}

		tx[points-2] -= tx[points-1];
		ty[points-2] -= ty[points-1];

		for(var i = points-2, pi = path.count-6; i>0; i--, pi -= 3)
		{
			tx[i] = (tx[i] - tx[i+1]) / tmpx[i];
			ty[i] = (ty[i] - ty[i+1]) / tmpy[i];
		}
	}

	function move(tick)
	{
		var index;
		var pindex = (index = tick \ time) * 3;
		var d = tick % time / time;

		var p = path;

		var l = (((zx[index+1] - zx[index])*d +
				zx[index]*3)*d +
				((p[pindex + 3] - p[pindex]) -
				(zx[index]*2 + zx[index+1]))) * d +
				p[pindex];

		var t = (((zy[index+1] - zy[index])*d +
				zy[index]*3)*d +
				((p[pindex + 4] - p[pindex+1]) -
				(zy[index]*2 + zy[index+1]))) * d +
				p[pindex+1];

		var so = p[pindex+2];
		var eo = p[pindex+5];

		var o = eo >= 256 ? so : int((eo-so)*d + so);

		kag.setLayerPos(l, t);
	}

}

//------------------------------------
//ch
function quake2_1(dg){
	var list=[];
	list[0]=0;
	list[1]=0;
	list[2]=0;

	var d1=0.8; var d2=1.0;
	for(var i=1; i<10; i++){
		d1+=1.81;
		d2+=1.23;
//		kag.fore.base.drawText( 400+Math.sin(d1)*50, 300+Math.cos(d2)*50, i, 0xffffff,,false,512,0x110022,1,1,1);
		list[i*3] = Math.sin(d1)*(10-i)*dg;
		list[i*3+1] = Math.cos(d2)*(10-i)*dg;
		list[i*3+2] = 0;
	}

	list[10*3]=0;
	list[10*3+1]=0;
	list[10*3+2]=0;

	return list;
}

//------------------------------------
// tf.quake2 ɃIuWFNg쐬BiŎgȂƁj
function quake2(type, time=50){
	var list;

	if(type==void) list=quake2_1(1);
	else if(type>=1 && type<=3) list=quake2_1(type);
	else if(type==4) list=[0,,,10,,,-10,,,8,,,-6,,,3,,,0,,];
	else if(type==5) list=[0,,,20,,,-20,,,16,,,-12,,,6,,,0,,];
	else if(type==6) list=[0,,,30,,,-30,,,24,,,-18,,,9,,,0,,];
	else if(type==7) list=[,0,,,10,,,-10,,,8,,,-6,,,3,,,0,];
	else if(type==8) list=[,0,,,20,,,-20,,,16,,,-12,,,6,,,0,];
	else if(type==9) list=[,0,,,30,,,-30,,,24,,,-18,,,9,,,0,];
	else if(type==10) list=[0,0,,10,10,,-10,10,,-10,-10,,10,-10,,0,0,];
	else return;

	if(tf.quake2 != void) tf.quake2.stopMove();
	tf.quake2=new QSplineMover(list,time,0,quake2end);
	tf.quake2.startMove();
}

//------------------------------------
// ㏈p֐
function quake2end(){
	tf.quake2 = void;
	kag.trigger('quake2end');
}

@endscript


;------------------------------------------------------------------
; S̉ʗh炵iftHgł͏I҂Ȃj
;		p[^
;			timeFMoverNXŎw肷鎞ԁi~bwjBȗ50~b
;			typeFh炵^CvBLQƁBȗ type=1
;
;		1:OO
;		2:OO~hꕝQ{
;		3:OO~hꕝR{
;		4:h(10pix)
;		5:h~2{
;		6:h~3{
;		7:ch(10pix)
;		8:ch~2{
;		9:ch~3{
;		10:P]
;
;		gpF@quake2 type=3 time=20
;
[macro name="quake2"]
@eval exp="quake2(mp.type, mp.time)"
[endmacro]

;------------------------------------------------------------------
; S̉ʗh炵I҂iftHgcanskip=falsej
[macro name="wq2"]
@waittrig * cond="tf.quake2!=void" name="quake2end"
@eval exp="if(tf.quake2!=void)tf.quake2.stopMove();"
[endmacro]


@return
